# Alarm Flight UI - Version 6

## ROS package

Perquisites:
```bash
wget https://repo.anaconda.com/archive/Anaconda3-2021.11-Linux-x86_64.sh
chmod +x ./Anaconda3-2021.11-Linux-x86_64.sh
./Anaconda3-2021.11-Linux-x86_64.sh
```
More anaconda installation options (for ARM64 etc):
https://www.anaconda.com/products/individual

After installing anaconda restart Terminal app.

:warning: For this version also Chromium browser is needed!
```bash
sudo apt install chromium-browser
```

Installation (recommended to re-install after every major version update)
```bash

cd /path/root/workspace

sudo chmod a+wr -R ~/.conda
conda remove --name alarm_flight_ui --all
conda env create --file ./src/alarm_flight_ui/scripts/environment.yml

chmod +x ./src/alarm_flight_ui/scripts/main.py

catkin_make
```

## Update installation

override `./src/alarm_flight_ui/scripts` contents

```bash
conda remove --name alarm_flight_ui --all
conda env create --file ./src/alarm_flight_ui/scripts/environment.yml

chmod +x ./src/alarm_flight_ui/scripts/main.py
```

## Launch package

```bash
conda activate alarm_flight_ui
source ./devel/setup.sh
roslaunch alarm_flight_ui main.launch
```

## Troubleshooting ROS package

There might be problem if you are running ROS using docker. Chromium browser need permission to access networking. It might be needed to commit image and re-create docker container. 

```bash
sudo docker commit [image_name]
sudo docker run --privileged [image_name]
```

## Troubleshooting other problems

Please if you experience issues send screenshots and `./logs/` files for us to analyze.

## Usage

Use File menu on top left corner to load PLY + TXT or pre-prepared Project file (*.flight). Then use ==double click== on map to add new POIs or select existing ones. When POI is created or selected use menus on right side panel to engage with them.

![image-20220405152624929](http://share.yellowrobot.xyz/upic/6248e0b89238556fe243d733b2bfbbc4_1652261094.png)

## Without ROS package

Installation

```bash
conda remove --name alarm_flight_ui --all
conda env create --file ./src/alarm_flight_ui/scripts/environment.yml
conda activate alarm_flight_ui
```

Launch using

```bash
python ./scripts/main.py
```

## Debugging in PyCharm

Use ./scripts as content root for the project



## Flight plan -  Version 6

With a function to have repeated loops (include steps in loops) and function to delay execution

![image-20220603143714516](http://share.yellowrobot.xyz/upic/a2836ec08435f10060c06fcde7ca3a6c_1654256235.png)

Status information panel is available in right side of dialog
![image-20220603143810936](http://share.yellowrobot.xyz/upic/fd82470890294ba6227f235ebc0fff51_1654256291.png)



## Video’s of usage

Version 5: http://share.yellowrobot.xyz/quick/2022-6-3-902DA7B7-05CC-4C00-8591-9E8B6B046558.mp4
Version 6: not yet sent

## Code documentation

Documentation of code and explanation of implementation of placeholder button in side panel:
http://share.yellowrobot.xyz/quick/2022-6-3-8BC65718-EF05-45B5-977D-AC5C604ABD45.html