class SortableFlightPlanPOIs extends React.Component {
    componentDidMount() {
        this.jSortable = $(this.refs.sortable);
        this.jSortable.sortable({
            handle: ".handle",
            opacity: this.props.opacity,
            update: (event, ui) => {
                let steps_order_uuids = $.map($('.sortable-pois'), it => $(it).attr("data-uuid"));
                this.props.onReOrderSteps(steps_order_uuids);
            }
        });
    }

    componentWillReceiveProps(nextProps) {
        if (nextProps.enable !== this.props.enable) {
            this.jSortable.sortable(nextProps.enable ? 'enable' : 'disable');
        }
    }

    renderItems() {
        let result = <></>;
        if(this.props.project && this.props.project.flight_plan) {
            result = this.props.project.flight_plan.steps.map((step, i) =>
                <div className="flight_plan_poi_row" key={`flight_plan_poi_row_${step.step_uuid}`}>
                    {this.props.isFlightPlanExecuting ? <span>&nbsp;</span> : <i class="material-icons handle"
                       style={{
                           alignSelf: "center",
                           cursor: "move",
                    }}>more_vert</i>}
                    <li key={`step-${i}`} className="ui-state-default sortable-pois" data-uuid={step.step_uuid}>
                        <ComponentFlightPlanPoi
                            step={step}
                            poi={step.poi_uuid && this.props.project.map_layers.layer_pois.pois.find(poi => poi.uuid === step.poi_uuid)}
                            isFlightPlanExecuting={this.props.isFlightPlanExecuting}
                            onDeleteStepByUUID={(uuid) => this.props.onDeleteStepByUUID(uuid)}
                        />
                    </li>
                </div>
            );
        }
        return result;
    }

    render() {
        return (
            <ul ref="sortable"
                style={{
                    listStyle: "none",
                    paddingLeft: 0,
                    maxHeight: "400px",
                    overflowY: "auto",
            }}>
                {this.renderItems()}
            </ul>
        );
    }

    componentWillUnmount() {
        this.jSortable.sortable('destroy');
    }
}
